package xcode

// Code 通用错误代码接口定义。
type Code interface {
	// Code 错误码。
	Code() int
	// Message 错误码简短信息。
	Message() string
	// Detail 错误码详细信息。
	Detail() any
}

// ================================================================================================================
// 公共错误码定义。
// 保留内部错误码: code < 1000。
// ================================================================================================================

var (
	CodeDefault              = 0
	CodeOK                   = 200
	CodeValidationFailed     = 501
	CodeInvalidParameter     = 503
	CodeMissingConfiguration = 507
	CodeNotAuthorized        = 401
	CodeUnknown              = 604
)
